#pragma once
#include "../jabyengine_defines.h"

namespace JabyEngine {
    namespace GTE {
        namespace internal {
            template<typename T>
            struct VECTOR {
                T x;
                T y;
                T z;
                T pad;

                static constexpr VECTOR create() {
                    return VECTOR::create(0, 0, 0);
                }

                static constexpr VECTOR create(T x, T y, T z) {
                    return VECTOR{.x = x, .y = y, .z = z, .pad = 0};
                }
            };
        }

        struct MATRIX {
            int16_t rot[3][3]; // Rotation matrix
            int32_t trans[3];  // Translation vector

            static constexpr MATRIX identity() {
                return MATRIX{
                    .rot = {
                        {1, 0, 0},
                        {0, 1, 0},
                        {0, 0, 1}
                    },
                    .trans = {0, 0, 0}
                };
            }
        };

        using VECTOR  = internal::VECTOR<int32_t>;
        using SVECTOR = internal::VECTOR<int16_t>;
    }
}